洛谷P3533 [POI2012]RAN-Rendezvous
P3533 [POI2012]RAN-Rendezvous
题目描述
Byteasar is a ranger who works in the Arrow Cave - a famous rendezvous destination among lovers.
The cave consists of nn chambers connected with one-way corridors.
In each chamber exactly one outgoing corridor is marked with an arrow.
Every corridor leads directly to some (not necessarily different) chamber.
The enamoured couples that agree to meet in the Arrow Cave are notorious for forgetting to agree upon specific chamber, and consequently often cannot find their dates.
In the past this led to many mix-ups and misunderstandings\dots But ever since each chamber is equipped with an emergency telephone line to the ranger on duty, helping the enamoured find their dates has become the rangers' main occupation.
The rangers came up with the following method.
Knowing where the enamoured are, they tell each of them how many times they should follow the corridor marked with an arrow in order to meet their date.
The lovers obviously want to meet as soon as possible - after all, they came to the cave to spend time together, not to wander around alone!
Most rangers are happy to oblige: they do their best to give each couple a valid pair of numbers such that their maximum is minimal.
But some rangers, among their numbers Byteasar, grew tired of this extracurricular activity and ensuing puzzles. Byteasar has asked you to write a program that will ease the process. The program, given a description of the cave and the current location of kk couples, should determine kk pairs of numbers x_ixi and y_iyi such that if the ii-th couple follows respectively: he x_ixiand she y_iyi corridors marked with arrows,then they will meet in a single chamber of the cave max(x_i,y_i)max(xi,yi) is minimal,subject to above min(x_i,y_i)min(xi,yi) is minimal,if above conditions do not determine a unique solution, then the woman should cover smaller distance (x_i\ge y_ixi≥yi).
It may happen that such numbers x_ixi and y_iyi do not exist - then let x_i=y_i=-1xi=yi=−1. Note that it is fine for several couples to meet in a single chamber. Once the lovers have found their dates, they will be happy to lose themselves in the cave again...
给定一棵内向森林,多次给定两个点a和b,求点对(x,y)满足:
1.从a出发走x步和从b出发走y…
输入输出格式
输入格式:
In the first line of the standard input there are two positive integers nn and kk(1\le n,k\le 500\ 0001≤n,k≤500 000), separated by a single space, that denote the number of chambers in the Arrow Cave and the number of couples who want to find their dates, respectively.
The chambers are numbered from 1 to nn, while the enamoured couples are numbered from 1 to kk.
The second line of input contains nn positive integers separated by single spaces:
the ii-th such integer determines the number of chamber to which the corridor marked with an arrow going out of chamber iileads.
The following kk lines specify the queries by the separated couples. Each such query consists of two positive integers separated by a single space - these denote the numbers of chambers where the lovers are - first him, then her.
In the tests worth 40% of the total points it additionally holds that n,k\le 2\ 000n,k≤2 000.
输出格式:
Your program should print exactly kk lines to the standard output, one line per each couple specified in the input:
the ii-th line of the output should give the instructions for the ii-th couple on the input.
I.e., the ii-th line of output should contain the integers x_i,y_ixi,yi, separated by a single space.
输入输出样例
说明
给定一棵内向森林,多次给定两个点a和b,求点对(x,y)满足:
1.从a出发走x步和从b出发走y步会到达同一个点
2.在1的基础上如果有多解,那么要求max(x,y)最小
3.在1和2的基础上如果有多解,那么要求min(x,y)最小
4.如果在1、2、3的基础上仍有多解,那么要求x>=y
/*
n个点,n条边且每个点都有出边,显然是环套树森林。
先dfs把环套树拆成一堆树,倍增LCA。
先将x,y两个点倍增到环上,然后判断即可。
*/
#include<cstdio>
#include<algorithm>
#define maxn 500050
using namespace std;
int n,fa[maxn][],root,q,circle[maxn],dep[maxn];
int num[maxn],sum[maxn],tot,pos[maxn],vis[maxn];
void findcircle(int x){
int now=x;
while(){
if(vis[x]==now)break;
if(vis[x])return;
vis[x]=now;
x=fa[x][];
}
tot++;
while(!circle[x]){
circle[x]=x;
dep[x]=;
num[x]=++sum[tot];
pos[x]=tot;
x=fa[x][];
}
}
void dfs(int x){
if(dep[x])return;
dfs(fa[x][]);
circle[x]=circle[fa[x][]];
dep[x]=dep[fa[x][]]+;
for(int i=;(<<i)<dep[x];i++)
fa[x][i]=fa[fa[x][i-]][i-];
}
int lca(int a,int b){
if(dep[a]!=dep[b]){
if(dep[a]<dep[b])swap(a,b);
for(int i=;i>=;i--)
if(dep[fa[a][i]]>=dep[b])a=fa[a][i];
}
if(a==b)return a;
for(int i=;i>=;i--)
if(fa[a][i]!=fa[b][i])
a=fa[a][i],b=fa[b][i];
if(a==b)return a;
return fa[a][];
}
bool judge(int a,int b,int c,int d){
if(max(a,b)<max(c,d))return ;
if(max(a,b)>max(c,d))return ;
if(min(a,b)<min(c,d))return ;
if(min(a,b)>min(c,d))return ;
if(a>=b)return ;
return ;
}
int main(){
freopen("Cola.txt","r",stdin);
scanf("%d%d",&n,&q);
for(int i=;i<=n;i++)scanf("%d",&fa[i][]);
for(int i=;i<=n;i++)findcircle(i);
for(int i=;i<=n;i++)if(!circle[i])dfs(i);
while(q--){
int x,y;
scanf("%d%d",&x,&y);
if(pos[circle[x]]!=pos[circle[y]]){
puts("-1 -1");continue;
}
if(circle[x]==circle[y]){
int t=lca(x,y);
printf("%d %d\n",dep[x]-dep[t],dep[y]-dep[t]);
continue;
}
int ans1=dep[x]-,ans2=dep[y]-,t=pos[circle[x]];
x=num[circle[x]];y=num[circle[y]];
int z1=(sum[t]+y-x)%sum[t];
int z2=sum[t]-z1;
if(judge(ans1+z1,ans2,ans1,ans2+z2))
printf("%d %d\n",ans1+z1,ans2);
else printf("%d %d\n",ans1,ans2+z2);
}
}
洛谷P3533 [POI2012]RAN-Rendezvous的更多相关文章
- 洛谷 P3539 [POI2012]ROZ-Fibonacci Representation 解题报告
P3539 [POI2012]ROZ-Fibonacci Representation 题意:给一个数,问最少可以用几个斐波那契数加加减减凑出来 多组数据10 数据范围1e17 第一次瞬间yy出做法, ...
- BZOJ2801/洛谷P3544 [POI2012]BEZ-Minimalist Security(题目性质发掘+图的遍历+解不等式组)
题面戳这 化下题面给的式子: \(z_u+z_v=p_u+p_v-b_{u,v}\) 发现\(p_u+p_v-b_{u,v}\)是确定的,所以只要确定了一个点\(i\)的权值\(x_i\),和它在同一 ...
- 洛谷P3538 [POI2012]OKR-A Horrible Poem [字符串hash]
题目传送门 A Horrible Poem 题目描述 Bytie boy has to learn a fragment of a certain poem by heart. The poem, f ...
- 洛谷P3539 [POI2012] ROZ-Fibonacci Representation
题目传送门 转载自:five20,转载请注明出处 本来看到这题,蒟蒻是真心没有把握的,还是five20大佬巨orz 首先由于斐波拉契数的前两项是1,1 ,所以易得对于任何整数必能写成多个斐波拉契数加减 ...
- 洛谷P3537 [POI2012]SZA-Cloakroom(背包)
传送门 蠢了……还以为背包只能用来维护方案数呢……没想到背包这么神奇…… 我们用$dp[i]$表示当$c$的和为$i$时,所有的方案中使得最小的$b$最大时最小的$b$是多少 然后把所有的点按照$a$ ...
- 洛谷P3531 [POI2012]LIT-Letters
题目描述 Little Johnny has a very long surname. Yet he is not the only such person in his milieu. As it ...
- 洛谷P3534 [POI2012] STU
题目 二分好题 首先用二分找最小的绝对值差,对于每个a[i]都两个方向扫一遍,先都改成差满足的形式,然后再找a[k]等于0的情况,发现如果a[k]要变成0,则从他到左右两个方向上必会有两个连续的区间也 ...
- 【洛谷3546_BZOJ2803】[POI2012]PRE-Prefixuffix(String Hash)
Problem: 洛谷3546 Analysis: I gave up and saw other's solution when I had nearly thought of the method ...
- bzoj 1014: 洛谷 P4036: [JSOI2008]火星人
题目传送门:洛谷P4036. 题意简述: 有一个字符串,支持插入字符,修改字符. 每次需要查询两个后缀的LCP长度. 最终字符串长度\(\le 100,\!000\),修改和询问的总个数\(\le 1 ...
随机推荐
- AngularJS学习笔记(四) 自定义指令
指令(directive)是啥?简单来说就是实现一定功能的XXX...之前一直用的ng-model,ng-click等等都是指令.当我有一个ng没提供的需求的时候,就可以自定义个指令.指令的好处显而易 ...
- python 链接sharepoint 2013 REST api
import requests,simplejson from requests_ntlm import HttpNtlmAuth p1 = requests.get("http://you ...
- 使用CSS3制作酷炫防苹果复选框 自行测试!
<!DOCTYPE html> <html lang="en"> <head> <meta charset="UTF-8&quo ...
- 关于c++中的全局变量(不赋值的全局变量算定义)
定义有三种: 1.不赋值的定义:int a; 2.赋值的定义:int a=5; 或者 int a;a=5; 3.加extern的定义:extern int a=5;//其实和不加是一样的. 声明只有一 ...
- bzoj-1588 1588: [HNOI2002]营业额统计(BST)
题目链接: 1588: [HNOI2002]营业额统计 Time Limit: 5 Sec Memory Limit: 162 MBSubmit: 13596 Solved: 5049[Submi ...
- poj2661 Factstone Benchmark(大数不等式同取对数)
这道题列出不等式后明显是会溢出的大数,但是没有必要写高精度,直接两边取对数(这是很简明实用的处理技巧)得: log2(n!)=log2(n)+log2(n-1)+...+log2(1)<=log ...
- mysql删除重复数据方法
create table tmp SELECT * from lhb t where t.id not in (select max(id) from lhb group by code,date,r ...
- ACM学习历程—HDU 5446 Unknown Treasure(数论)(2015长春网赛1010题)
Problem Description On the way to the next secret treasure hiding place, the mathematician discovere ...
- BZOJ4756:[USACO2017JAN]Promotion Counting
浅谈线段树合并:https://www.cnblogs.com/AKMer/p/10251001.html 题目传送门:https://lydsy.com/JudgeOnline/problem.ph ...
- yum配置文件位置
centos的yum配置文件 cat /etc/yum.conf cachedir=/var/cache/yum //yum 缓存的目录,yum 在此存储下载的rpm 包和数据库,默认设置为/var/ ...